library jsonbject;

import 'package:json/json.dart';
import 'dart:mirrors';

class Jsonbject {
  final Map map;
  
  Jsonbject(this.map);
  
  Jsonbject.fromString (String json) :
    this.map = parse(json);
  
  String get asString => stringify(map);
  
  dynamic noSuchMethod (Invocation invocation) {
    String member = MirrorSystem.getName(invocation.memberName);
    if (invocation.isGetter) {
      return map[member];
    } else if (invocation.isSetter) {
      map[member] = invocation.positionalArguments.first;
    }
  }
  
  operator == (Jsonbject other) => map == other.map;
  
  operator [] (key) => map[key];
  
  operator []= (key, value) => map[key] = value;
}